#include "Servo.h"

// définition des servo
Servo servoDvert; // création de l'objet "servo droit vertical"
Servo servoDhor; // création de l'objet "servo droit horizontal"
Servo servoGhor; // création de l'objet "servo gauche horizontal"


//définition des seuils pour le micro
const unsigned long dureeMinimum = 2000; // 2 secondes
const int valeurinf = 670; //valeur qui déclenchera l'applaudissement
const int valeursup = 780; //valeur qui déclenchera la claque
const float SOUND_SPEED = 340.0 / 1000; // Vitesse du son dans l'air en mm/us 

bool enMesure;
long topDepart;
long topaclap;
long topacri;
long topalarme;
long duree; 
long maxson ; 

// Capteur ultrason
const byte TRIGGER_PIN = 2; // Broche TRIGGER
const byte ECHO_PIN = 3;    // Broche ECHO
const unsigned long MEASURE_TIMEOUT = 25000UL; // 25ms = ~8m à 340m/s ie constante pour le timeout



void setup() {
  // initialize serial communication at 9600 bits per second:
  Serial.begin(9600);
  // servo
  servoDvert.attach(10); // attache le servo au pin spécifié
  servoDhor.attach(11); // attache le servo au pin spécifié
  servoGhor.attach(12); // attache le servo au pin spécifié

  //initialise le capteur à ultrason
  pinMode(TRIGGER_PIN, OUTPUT);
  digitalWrite(TRIGGER_PIN, LOW); 
  pinMode(ECHO_PIN, INPUT);

  // haut parleur
  pinMode(9, OUTPUT);

  //micro 
  pinMode (A0, INPUT);

  enMesure = false;
}


void loop() {
  // capteur de niveau sonore
  int son = analogRead(A0);
  //Serial.println(son);
  

  // capteur de distance à la boite
  // 1. Lance une mesure de distance en envoyant une impulsion HIGH de 10µs sur la broche TRIGGER 
  digitalWrite(TRIGGER_PIN, HIGH);
  delayMicroseconds(10);
  digitalWrite(TRIGGER_PIN, LOW); 
  // 2. Mesure le temps entre l'envoi de l'impulsion ultrasonique et son écho (si il existe) 
  long measure = pulseIn(ECHO_PIN, HIGH, MEASURE_TIMEOUT);
  // 3. Calcul la distance à partir du temps mesuré 
  float distance_mm = measure / 2.0 * SOUND_SPEED; 
  Serial.println(distance_mm);


  if (enMesure) { // on était au dessus du seuil, l'est-on encore ?
    if (son < valeurinf  && (millis() - topDepart) > dureeMinimum ) { // si on est toujours bon et depuis assez longtemps
      topaclap = millis();
      enMesure = false ; 
      while ( - topaclap + millis() < 5000){ // on applaudi pendant 5 secondes
        son = analogRead(A0);
        servoDhor.write(90);
        servoGhor.write(100); // 100 pour pouvoir prendre du recul cf claque
        delay(300);
        servoDhor.write(0);
        servoGhor.write(10);
        delay(300);
      }
      son = analogRead(A0);
    } 
    if (son < valeurinf){
    delay(10);
    }
    else { // on est revenu au dessus le seuil
      enMesure = false;
    }
  } else { // on attend le franchissement de seuil 
    if (son < valeurinf) { // on passe le seuil, on commence à compter
      topDepart = millis();
      enMesure = true;
    }

    if (distance_mm < 700 ){
      // déclenchement de la claque
      servoDvert.write(90); // on baisse le bras droit
      delay(500);
      servoGhor.write(0);
      delay(100);
      servoGhor.write(100);
      delay(500); // remise à zéro des positions
      servoGhor.write(10);
      delay(1000);
      servoDvert.write(0);
      }

    if (son > valeursup){ 
      /* topacri = millis();
      maxson = valeursup +1;
        while ( maxson > valeursup){
          son = analogRead(A0);
          maxson = 0;
          for ( int j = 0 ; j < 10 ; j++){
            delay(10);
            maxson = max(analogRead(A0), maxson) ;
          }
        }
      // déclenchement du cri
       duree = - topacri + millis() ; */
       topalarme = millis();
       while (millis() - topalarme < 2000){
        
         for (int i = 2000; i<=4000; i++){
           tone (9, i, 30);
          }
          for (int i = 2000; i>=4000; i--){
            tone (9, i, 30);
          }

       }
    }
    
  } 
          }

       
    


